*
      SUBROUTINE CAL_GESVN(NAME, TRANS, N, NPROW,NPCOL, AMEM, MEMSIZE,
     $                     NB, INFILEA, INFILEB, OUTFILE, TFILE,
     $                     NPRT, CTXT)
*
*     
* (PDGESV, PDGESV1, PDGESV2, PDGESV3)
*        
*     
*
      include 'mpif.h'
*
*  
      INTEGER            N, NPROW, NPCOL, NB, MEMSIZE, NPRT, CTXT
      DOUBLE PRECISION   AMEM( MEMSIZE )
      CHARACTER*(*)      INFILEA, INFILEB, OUTFILE, TFILE, NAME, TRANS
*
*   -  
      INTEGER            NOUT, NOUT1, NIN, NPR
      PARAMETER          ( NOUT1 = 12, NOUT = 13, NIN = 11, NPR = 6 )
*
*  
      INTEGER            I, IAM, INFO, IPA, IPB, IPX, IPW,
     $                   IPPIV, IPAF, IPFER, IPBER, IPWOR, IPIWOR,
     $                   IPLWORK, IPLIWORK, J, MYCOL, MYROW, NP, NQ,
     S                   NBRHS, NRHS, NQRHS, LWORK, LIWORK,
     $                   IA, JA, IB, JB, IAF, JAF, IX, JX,
     $                   NPROCS, MMIN, WORKSIZ
*
*  
      INTEGER            DESCA( 9), DESCB( 9), DESCX( 9), DESCAF( 9),
     $                   ILIWORK(1)
      DOUBLE PRECISION   ALWORK(1), time, time1, time2
*
      COMMON             time, J
*  
      INTEGER            ICEIL, ILCM, NUMROC
      DOUBLE PRECISION   PDLAMCH, PDLANGE
      EXTERNAL           ICEIL, ILCM, NUMROC, PDLAMCH, PDLANGE
*
*  
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PDLAPRNT, PDLAREAD,
     $                   PDLAWRITE, MINTGESV,
     $                   PDGESV, PDGESV1, PDGESV2, PDGESV3
*
*  
*
*  
*
**      NPROCS = NPROW*NPCOL
      IA = 1
      JA = 1
      IB = 1
      JB = 1
      IAF = 1
      JAF = 1
      IX = 1
      JX = 1
      NRHS = 1
*?
      NBRHS = 1
*
*    BLACS'    
*
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
*       ,
*    
*
      IF( MYROW.GE.NPROW .OR. MYCOL.GE.NPCOL ) GO TO 20
*
       NP = NUMROC( N, NB, MYROW, 0, NPROW )
       NQ = NUMROC( N, NB, MYCOL, 0, NPCOL )
       NQRHS = NUMROC( NRHS, NB, MYCOL, 0, NPCOL )
*
*     A, AF,   X
*
      CALL DESCINIT( DESCA, N, N, NB, NB, 0, 0, CTXT, MAX(1,NP), INFO)
      CALL DESCINIT(DESCB, N, NRHS, NB,NBRHS, 0,0, CTXT,MAX(1,NP),INFO)
      CALL DESCINIT(DESCX, N, NRHS, NB,NBRHS, 0,0, CTXT,MAX(1,NP),INFO)
      CALL DESCINIT(DESCAF, N, N, NB, NB, 0, 0, CTXT, MAX(1,NP), INFO)
*
*     AMEM
*
*     A
      IPA = 1
*
*    ()   B
*
      IPB = IPA + DESCA( 9 )*NQ
*
*      
*   
*
      IPPIV = IPB + DESCB( 9 )*NQRHS
      LIPIV = ICEIL( 4*(NP+NB), 8 )
      IPW =IPPIV + MAX( NP, LIPIV )
*
      IF( NAME .NE. 'PDGESV3' ) GOTO 1
*
      IPAF = IPPIV + MAX( NP, LIPIV )
      IPX = IPAF + DESCAF( 9 )*NQ
*
      IPFER = IPX + DESCX( 9 )*NQRHS
      IPBER = IPFER + DESCX(9)*NQRHS
      IPWOR = IPBER + DESCX(9)*NQRHS
*
      NQB = ICEIL( N, NB*NPCOL )
      LCM = ILCM( NPROW, NPCOL )
      LCMQ = LCM / NPCOL
*
*   ,    PDGESV3
*
      LWORK = 4*NP + NQ + ICEIL(NQB, LCMQ)*NB
      LIWORK = NP
*
      IPIWOR = IPWOR + LWORK
      IPW = IPIWOR + LIWORK
      GO TO 3
*
    1 IF( NAME .NE. 'PDGESV2' ) GOTO 7
*
      IPWOR =IPPIV + MAX( NP, LIPIV )
*
*   ,    PDGESV2
*
***      LWORK = 3*NP + 2*NQ
      LWORK = 2*NP + 2*NQ
     $       + MAX(2, MAX(NB*MAX(1, ICEIL(NPROW-1, NPCOL)),
     $                   NQ + NB*MAX(1, ICEIL(NPCOL-1, NPROW))))
      LIWORK = NP
*
      IPIWOR = IPWOR + LWORK
      IPW = IPIWOR + LIWORK
      GOTO 3
    7 IF( NAME .NE. 'PDGESV' .AND. NAME .NE. 'PDGESV1') GOTO 10
      GO TO 3
*
*     PDLAPRNT  .
*
    3 WORKSIZ = MAX( NB, NP )
*
      INFO = 0
      MMIN = IPW + WORKSIZ
*
*      ( MMIN )
*
      IF(IPW + WORKSIZ .GT. MEMSIZE ) THEN
         IF( IAM .EQ. 0 ) WRITE( NPR, FMT = * )'  '
         WRITE( NPR, FMT = * ) MMIN, MEMSIZE
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         WRITE( NOUT, FMT = * ) MMIN, MEMSIZE
         IF( IAM .EQ. 0 ) WRITE( NOUT, FMT = * )'  '
         INFO = 1
      END IF
*
*   INFO    
*
      CALL IGSUM2D( CTXT, 'All', ' ', 1, 1, INFO, 1, -1, 0 )
      IF( INFO .GT. 0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 )
     $       WRITE( NOUT, FMT = * ) '   '
         WRITE( NOUT, FMT = * ) MMIN, MEMSIZE
         GO TO 10
      END IF
*
*   ( )     A  B
*
      IF( INFILEA .EQ. ' ' ) THEN
         CALL MINTGESV( N, AMEM(IPA), DESCA, AMEM(IPB), DESCB, INFO )
      ELSE
         CALL PDLAREAD(INFILEA, AMEM(IPA), DESCA, 0, 0, AMEM(IPW))
         CALL PDLAREAD(INFILEB, AMEM(IPB), DESCB, 0, 0, AMEM(IPW))
      END IF
*
*    
      IF( NPRT .EQ. 0 .OR. NPRT .EQ. 1 .OR. NPRT .EQ. 2 ) GO TO 8
      IF( J .NE. 1 ) GO TO 8
*
*   
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )N, N, NB, NB
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NPR, FMT = * ) '     '
         WRITE( NPR, FMT = * )'   IPA,   IPB,   IPPIV, IPW,  MMIN'
         WRITE( NPR, FMT = 9994 )IPA, IPB, IPPIV, IPW, MMIN
*
         IF( NAME .NE. 'PDGESV3' ) GOTO 4
         WRITE( NPR, FMT = * )'   IPAF,   IPX, IPFER,   IPBER, IPWOR'
         WRITE( NPR, FMT = 9994 )IPAF, IPX, IPFER, IPBER, IPWOR
    4    IF( NAME .EQ. 'PDGESV' ) GOTO 5
         WRITE( NPR, FMT = 9983 ) TRANS
    5    WRITE( NPR, FMT = * ) '  DESCA'
         WRITE( NPR, FMT = 9985 )DESCA
         WRITE( NPR, FMT = * ) '  DESCB'
         WRITE( NPR, FMT = 9985 )DESCB
         WRITE( NPR, FMT = * ) '  DESCX'
         WRITE( NPR, FMT = 9985 )DESCX
         IF( NAME .NE. 'PDGESV3' ) GOTO 2
         WRITE( NPR, FMT = * ) '  DESCAF'
         WRITE( NPR, FMT = 9985 )DESCAF
    2    WRITE( NPR, FMT = * ) '  A'
      END IF
*
 9994 FORMAT( / 5I7 /)
 9983 FORMAT( / 'TRANS = ', A /)
 9985 FORMAT( / 9I5 /)
*
      CALL PDLAPRNT( N, N, AMEM(IPA), IA, JA, DESCA, 0, 0, 'A',
     $               NPR, AMEM( IPW ) )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  B'
      END IF
*
      CALL PDLAPRNT( N, NRHS, AMEM(IPB), IB, JB, DESCB, 0, 0, 'B',
     $               NPR, AMEM( IPW ) )
*
*    A * X = B
*
    8 IF( NAME .EQ. 'PDGESV1' ) GOTO 11
      IF( NAME .EQ. 'PDGESV2' ) GOTO 12
      IF( NAME .EQ. 'PDGESV3' ) GOTO 14
      IF( NAME .NE. 'PDGESV' ) GOTO 10
*
      time1 = MPI_Wtime()
*
      CALL PDGESV( N, NRHS, AMEM(IPA), IA, JA, DESCA, AMEM(IPPIV),
     $              AMEM(IPB), IB, JB, DESCB, INFO )
*
      time2 = MPI_Wtime()
      time = time2 - time1
*
 9999 FORMAT( /' (Wtime) =', D14.3, ' time1 =', D12.3,
     $        ' time2 =', D14.3 )
*
      GOTO 99
*
   11 CONTINUE
      time1 = MPI_Wtime()
*
      CALL PDGESV1( TRANS, N, NRHS, AMEM(IPA), IA, JA, DESCA,
     $              AMEM(IPPIV), AMEM(IPB), IB, JB, DESCB, INFO )
*
      time2 = MPI_Wtime()
      time = time2 - time1
*
      GOTO 99
*
   12 CONTINUE
      time1 = MPI_Wtime()
*
      CALL PDGESV2( TRANS, N, NRHS, AMEM(IPA), IA, JA, DESCA,
     $              AMEM(IPPIV), AMEM(IPB), IB, JB, DESCB,
     $              RCOND, AMEM(IPWOR), LWORK, AMEM(IPIWOR),
     $              LIWORK, INFO)
*
      time2 = MPI_Wtime()
      time = time2 - time1
*
      GOTO 99
*
   14 CONTINUE
      time1 = MPI_Wtime()
*
      CALL PDGESV3( TRANS, N, NRHS, AMEM(IPA), IA, JA, DESCA,
     $              AMEM(IPAF),IAF, JAF, DESCAF, AMEM(IPPIV),
     $              AMEM(IPB), IB, JB, DESCB, AMEM(IPX), IX, JX, DESCX,
     $              AMEM(IPFER), AMEM(IPBER),   
     $              AMEM(IPWOR), LWORK, AMEM(IPIWOR), LIWORK, INFO)
*
      time2 = MPI_Wtime()
      time = time2 - time1
*
      GOTO 99
*           
*   X
*
   99 CONTINUE
*
*      
*
      IF( J .NE. 1 .AND. J .NE. 2000 ) GO TO 17
      IF( NPRT .EQ. 0 .OR. NPRT .EQ. 1 ) GO TO 27
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  '
      IF( NAME .NE. 'PDGESV2' ) GOTO 18
         WRITE( NPR, FMT = 9995 )INFO, RCOND
         GO TO 19
   18    WRITE( NPR, FMT = 9996 )INFO
*         WRITE( NPR, FMT = 9984 )AMEM(IPW)
   19    WRITE( NPR, FMT = * ) '   X'
      END IF
*
      IF( NAME .NE. 'PDGESV3' ) GOTO 15
*
      IF( N .LE. 1000 ) GO TO 23
*
      CALL PDLAPRNT( 3, NRHS, AMEM(IPX), IX, JX, DESCX, 0,0, 'X', NPR,
     $               AMEM( IPW ) )
      GO TO 27
*
   23 CALL PDLAPRNT( N, NRHS, AMEM(IPX), IX, JX, DESCX, 0,0, 'X', NPR,
     $               AMEM( IPW ) )
      GO TO 27
*
   15 IF( N .LE. 1000 ) GO TO 25
*
      CALL PDLAPRNT( 3, NRHS, AMEM(IPB), IB, JB, DESCB, 0,0, 'X', NPR,
     $               AMEM( IPW ) )
      GO TO 27
*
   25 CALL PDLAPRNT( N, NRHS, AMEM(IPB), IB, JB, DESCB, 0,0, 'X', NPR,
     $               AMEM( IPW ) )
*
   27 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
        WRITE( NPR, FMT = * )' : ', MMIN, MEMSIZE
      END IF
   17 CONTINUE
*
*        
*  ,      ' '.
*
      IF( OUTFILE .EQ. ' ' ) GO TO 21
*
      IF( NAME .NE. 'PDGESV3' ) GOTO 16
*
      CALL PDLAWRITE( OUTFILE, N, NRHS, AMEM(IPX), 1, 1, DESCX,
     $                0, 0, AMEM(IPW) )
      GO TO 10
*
   16 CALL PDLAWRITE( OUTFILE, N, NRHS, AMEM(IPB), 1, 1, DESCB,
     $                0, 0, AMEM(IPW) )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         IF( NOUT .NE. 6 .AND. NOUT .NE. 0 ) CLOSE( NOUT )
      END IF
*
   21 CONTINUE
*
*       
*   ,  
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
*
      IF( J .NE. 1 .AND. J .NE. 2000 ) GO TO 28
        WRITE( NOUT1, FMT = * )' : ', MMIN, MEMSIZE
*
   28   WRITE( NOUT1, FMT = 2001 ) NPROW, NPCOL, NB, time
*
**         WRITE( NOUT1, FMT = 9999 )time, time1, time2
      END IF
*
   10 CONTINUE
*
   20 CONTINUE
*
 2001 FORMAT( 3I5, D14.3/ )
*
 9992 FORMAT( / '    ', A7 )
 9998 FORMAT(/'  A X = B ,'//' A - ',I5,' ',I5,',',
     $       /'        ', I3, '  ', I3, /)
 9997 FORMAT( / '   ', I3, ' ,',
     $       '    ', I3, '  ', I3 /)
 9995 FORMAT( / '  INFO =', I6, '   RCOND  = ', E16.8 /)
 9996 FORMAT( / '  INFO  = ', I6 /)
      RETURN
      END
